import greenfoot.*;	 // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class PlayerShip here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class PlayerShip extends Player {
  final int MAX_PLAYER_HEALTH = 100;
  private int health = MAX_PLAYER_HEALTH;
  final int LOSE_INVINCIBILITY = 500;
  private int invincibility = 350;
  private GreenfootImage image1, image2,
            	           image3, image4, 
            	           image5, image6, 
            	           image7, image8, 
            	           image9, image10;

  public PlayerShip() {
    image1 = new GreenfootImage("playerA.png");
    image2 = new GreenfootImage("playerB.png");
    image3 = new GreenfootImage("playerC.png");
    image4 = new GreenfootImage("playerBackA.png");
    image5 = new GreenfootImage("playerBackB.png");
    image6 = new GreenfootImage("playerDownA.png");
    image7 = new GreenfootImage("playerDownB.png");
    image8 = new GreenfootImage("playerUpA.png");
    image9 = new GreenfootImage("playerUpB.png");
    image10 = new GreenfootImage(100, 100);
    setImage(image1);
  }

  /**
   * Act - do whatever the PlayerShip wants to do. This method is called whenever
   * the 'Act' or 'Run' button gets pressed in the environment.
   */
  public void act() {
    updateImage();
    //flashingImage();
    shootReload();
    movement();
    updatePowers();
  }  
  
  public boolean isInvincible() {
  	if (invincibility < LOSE_INVINCIBILITY) {
    return true;
  	}
  	return false;
  }
  
  public void updatePowers() {
  	invincibility++;
  }
  
  public void updateImage() {
    Mover move = (Mover) getOneObjectAtOffset(0, 0, Mover.class);
    if (move.getRotation() == 0) {
      if (getImage() == image1) {
        setImage(image2);
      } else if (getImage() == image2) {
        setImage(image3);
      } else setImage(image1);
    } else if (move.getRotation() == 180) {
      if (getImage() == image1) {
        setImage(image4);
      } else if (getImage() == image4) {
        setImage(image5);
      } else setImage(image1);
    } else if (move.getRotation() == 90) {
      if (getImage() == image1) {
        setImage(image6);
      } else if (getImage() == image6) {
        setImage(image7);
      } else setImage(image1);
    } else if (move.getRotation() == 270) {
      if (getImage() == image1) {
        setImage(image8);
      } else if (getImage() == image8) {
        setImage(image9);
      } else setImage(image1);
    } else setImage(image1);
  }
 
  public void flashingImage() {
    if (isInvincible()) {
      if (getImage() != image10) {
        setImage(image10);
      } else if (getImage() == image10) {
        setImage(image1);
      } 
    }
  }
  
  public void movement() {
    if (canSee(Mover.class)) {
      Mover move = (Mover) getOneObjectAtOffset(0, 0, Mover.class);
      int x = move.getX();
      int y = move.getY();
      if (getImage() == image2) {
        setLocation(x - 4, y);
      } else if (getImage() == image3) {
        setLocation(x - 5, y);
      } else if (getImage() == image6 || getImage() == image8) {
        setLocation(x - 4, y);
      } else if (getImage() == image7 || getImage() == image9) {
        setLocation(x - 5, y);
      } else setLocation(x, y);
      //Greenfoot.playSound("jets.wav");
    }
  }

  public void shootReload() {
    if ((reload % 15) != 0) {
      reload--;
    } else shoot();
  }
  
  public void setInvincibility(int newVal) {
    invincibility = newVal;
  }

  public int getInvincibility() {
    return invincibility;
  }
  
  public void setHealth(int newHealth) {
    health = newHealth;
  }

  public int getHealth() {
    return health;
  }
}
