import greenfoot.*;// (World, Actor, GreenfootImage, Greenfoot and MouseInfo)interface List;
import java.util.List;

/**
 * Write a description of class SpaceWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class SpaceWorld extends World {
  private int worldTimer = 0;
  private int lifeCount = 0;
  
  /**
   * Constructor for objects of class SpaceWorld.
   * 
   */
  public SpaceWorld() {
    super(1280, 720, 1); 
    prepare();
  }

  public void act() {
    populateWorld();
    checkWall();
    respawn();
  }

  public void prepare() {
    addPlayer(200,getHeight() / 2);
    addWall();
    addLifeTicks();
    addScore();
  }
  
  public void addScore() {
    addObject(new Score(), getWidth() - 100, 36);
  }
  
  public void addPlayer(int x, int y) {
    addObject(new PlayerShip(), x, y);
    addObject(new Mover(), x, y);
    addObject(new Healthbar(), x - 55, y - 55);
    addObject(new Healthbar(), x - 20, y - 55);
    addObject(new Healthbar(), x + 15, y - 55);
    addObject(new Healthbar(), x + 50, y - 55);
  }

  public void addLifeTicks() {
    addObject(new Life(), 450, 31);
    addObject(new Life(), 490, 31);
    addObject(new Life(), 530, 31);
  }
  public void addWall() {
    addObject(new SpaceWall(), 0, 360);
    for (int i = 2; i <= 12; i += 2) {
      addTick(80 + i * 20, 31);
    }
  }

  public void populateWorld() {
    addSS(500);
    if (worldTimer >= 1500 && worldTimer <= 2500) {
      addSS(1000);
      addLS(10000);
      addPowerup(10000);
    } else if (worldTimer > 3000 && worldTimer <= 5000) {
      addSS(750);
      addLS(850);
      addPowerup(1000);
    }
    worldTimer++;
  }

  public void addLS(int spawnRate) {
    int spawnChance = Greenfoot.getRandomNumber(spawnRate) + 1;
    int x = getWidth();
    int y = Greenfoot.getRandomNumber(getHeight());
    if (y < 100) {
      y += 100;
    } else if (y > getHeight() - 20) {
      y -= 20;
    }
    if (spawnChance <= 5) {
      addObject(new LargeShip(), x, y);
    }
  }

  public void addSS(int spawnRate) {
    int spawnChance = Greenfoot.getRandomNumber(spawnRate) + 1;
    int x = getWidth();
    int y = Greenfoot.getRandomNumber(getHeight());
    if (y < 100) {
      y += 100;
    } else if (y > getHeight() - 20) {
      y -= 20;
    }
    if (spawnChance <= 5) {
      addObject(new SmallShip(), x, y);
    }
  }

  public void addPowerup(int spawnRate) {
    int spawnChance = Greenfoot.getRandomNumber(spawnRate) + 1;
    int x = getWidth();
    int y = Greenfoot.getRandomNumber(getHeight());
    if (y < 100) {
      y += 100;
    } else if (y > getHeight() - 20) {
      y -= 20;
    }
    if (spawnChance <= 5) {
      addObject(new Powerup(), x, y);
    }
  }

  public void removeTick(int x, int y) {
    List<Tick> tickList = getObjectsAt(x, y, Tick.class);
    if (tickList.size() > 0) {
      Tick wallTick = tickList.get(0);
      removeObject(wallTick);
    }
  }

  public void addTick(int x, int y) {
    addObject(new Tick(), x, y);
  }

  public void checkWall() {
    List<SpaceWall> wallList = getObjectsAt(0, 360, SpaceWall.class);
    if (wallList.size() > 0) {
      SpaceWall wall = wallList.get(0);
      if (wall.getHealth() < 150) {
        removeTick(320, 31);
      } /* else if (wall.getHealth() == 150) {
        addTick(320, )
      }*/
      if (wall.getHealth() < 125) {
        removeTick(280, 31);
      }
      if (wall.getHealth() < 100) {
        removeTick(240, 31);
      }
      if (wall.getHealth() < 75) {
        removeTick(200, 31);
      }
      if (wall.getHealth() < 50) {
        removeTick(160, 31);
      }
      if (wall == null) {
        removeTick(120, 31);
      }
    } else {
      removeTick(120, 31);
      addObject(new GameOver(), 640, 360);
      Greenfoot.stop();
    }
}

  public boolean checkForLife() {
    List<PlayerShip> checkAlive = getObjects(PlayerShip.class);
    if (checkAlive.size() > 0) {
      return true;
    }
    return false;
  }

  public void loseLife() {
    lifeCount++;
    if (lifeCount == 3) {
      removeLife(450, 31);
    } else if (lifeCount == 2) {
      removeLife(490, 31);
    } else if (lifeCount == 1) {
      removeLife(530, 31);
    }
  }
  
  public void removeLife(int x, int y) {
    List<Life> lifeList = getObjectsAt(x, y, Life.class);
    if (lifeList.size() > 0) {
      Life menuLife = lifeList.get(0);
      removeObject(menuLife);
    }
  }

  public void respawn() {
    if (!checkForLife() && lifeCount < 3) {
      //List<SmallShip> ss = getObjects(SmallShip.class);
      //List<LargeShip> ls = getObjects(LargeShip.class);
      //removeObjects(ss);
      //removeObjects(ls);
      addPlayer(200, 360);
      addObject(new Shield(), 200, 360);
      loseLife();
    } else if (lifeCount > 3) {
        addObject(new GameOver(), 640, 360);
        Greenfoot.stop();
    } else if (lifeCount == 3) {
      loseLife();
    }
  }
}
